#pragma once

#include "trigger.hpp"

enum ControlEvent {
  NONE,
  RECORD,
  UNDO,
  REDO,
  END
};

struct Control {
  bool recordInput = false;
  bool undoInput = false;
  bool redoInput = false;
  BooleanTrigger recordTrigger;
  BooleanTrigger undoTrigger;
  BooleanTrigger redoTrigger;
  ControlEvent event = NONE;

  ControlEvent process() {
    event = NONE;

    int recordEvent = recordTrigger.processEvent(recordInput);
    if (recordEvent > 0) {
      event = RECORD;
    }
    if (recordEvent < 0) {
      event = END;
    }

    int undoEvent = undoTrigger.processEvent(undoInput);
    if (undoEvent > 0) {
      event = UNDO;
    }

    int redoEvent = redoTrigger.processEvent(redoInput);
    if (redoEvent > 0) {
      event = REDO;
    }

    return event;
  }
};