#pragma once

#include "segment.hpp"

/**
 * Class: Operation
 *
 * An operation processes audio input and output.
 * An operation manages its own state and memory access for an audio operation like record, overdub etc.
 */
struct Operation {
  float *input;
  Operation(float *input) : input(input) {}
  virtual bool shouldProcess() = 0;
  virtual float process(float deltaTime) = 0;
  virtual void end() = 0;
  virtual void terminate() = 0;
  virtual void recover() = 0;
  virtual Segment getNextSegment() = 0;
};