#pragma once

#include "operation.hpp"
#include "samples.hpp"
#include "segment.hpp"

/**
 * Class: RootOp
 *
 * RootOp represents the initial state of a looper. It is the "null object" of operations.
 */
struct RootOp : Operation {
  Samples *samples;

  RootOp(Samples *samples) : Operation(nullptr), samples(samples) {}

  bool shouldProcess() { return false; }
  float process(float deltaTime) { return 0.f; }
  void end() {}
  void terminate() {}
  void recover() {}

  Segment getNextSegment() {
    return Segment{samples, 0};
  }
};