#pragma once

#include <vector>

/**
 * Class: Samples
 *
 * A single instance of Samples is used to store all audio data for the looper.
 * Writing beyond the end of the vector will wrap around to the beginning.
 * The vector's size is predetermined to avoid allocating memory during audio processing.
 */
struct Samples {
  std::vector<float> samples;

  Samples(int size) : samples(size) {}

  float read(int i) {
    return samples[i % samples.size()];
  }

  void write(int i, float input) {
    samples[i % samples.size()] = input;
  }
};
